<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Cacti – How To Setup SSH Tunnels to graph a remote Unix server</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
  <link rel="stylesheet" href="Cacti-Github.css" />
</head>
<body>
<h1 id="how-to-setup-ssh-tunnels-to-graph-a-remote-unix-server">How To Setup SSH Tunnels to graph a remote Unix server</h1>
<p>Howto created by <code>fmangeant</code> at <a href="http://forums.cacti.net/viewtopic.php?t=24960">Cacti Forum</a></p>
<p>This HowTo will explain how to use SSH tunnels to graph a Unix server that isn't directly reachable by your Cacti server :</p>
<p><img src="images/device-templates-ssh-tunnel.png" alt="Overview" /></p>
<p>In this example, the Cacti server can reach the Gateway, which can reach the target server.</p>
<h2 id="configuring-the-ssh-tunnel">Configuring the SSH tunnel</h2>
<p>On Gateway, create a "cactiuser" user :</p>
<pre class="console"><code># useradd -d /home/cactiuser -m cactiuser
</code></pre>
<p>Then you have to generate SSH keys (without passphrase) :</p>
<pre class="console"><code># su - cactiuser
$ ssh-keygen -t rsa
Generating public/private rsa key pair.
Enter file in which to save the key (/home/cactiuser/.ssh/id_rsa):
Enter passphrase (empty for no passphrase):
Enter same passphrase again:
Your identification has been saved in /home/cactiuser/.ssh/id_rsa.
Your public key has been saved in /home/cactiuser/.ssh/id_rsa.pub.
The key fingerprint is:
40:f6:91:a1:2d:d1:46:d4:76:e3:d8:c6:3f:c2:cf:f2 cactiuser@gateway
```console

The public key of the &quot;cactiuser&quot; user has then to be authorized as an input key :

```console
$ cd $HOME/.ssh
$ cp -p id_rsa.pub authorized_keys
</code></pre>
<p>Finally, create the SSH tunnel :</p>
<pre class="console"><code># su - cactiuser -c &quot;ssh -f -N -g -L 192.168.0.2:10000:192.168.1.2:161 cactiuser@localhost&quot;
</code></pre>
<p>This SSH tunnel will forward all packets sent to 192.168.0.2 on TCP port 10000, to 192.168.1.2 on port TCP 161.</p>
<p>The options that are used are the following :</p>
<pre class="shell"><code>-f : requests SSH to go to background just before command execution
-N : do not execute a remote command
-g : allows remote hosts to connect to local forwarded ports
-L : specifies that the given port on the local (client) host is to be forwarded to the given host and port on the remote side.
</code></pre>
<p>You can add this command to <code>/etc/rc.local</code>, so it will be executed at boot time.</p>
<h2 id="configuring-net-snmp">Configuring Net-SNMP</h2>
<p>By default, the Net-SNMP agent listens on UDP port 161; we'll modify its configuration to listen on TCP port 161.</p>
<p>To do so, use that in <code>snmpd.conf</code> on the target server :</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode ini"><code class="sourceCode ini"><a class="sourceLine" id="cb5-1" title="1"><span class="dt">agentaddress tcp:161</span></a>
<a class="sourceLine" id="cb5-2" title="2"><span class="dt">rocommunity mycommunity</span></a></code></pre></div>
<p>For a more detailed configuration of snmpd.conf, follow the <a href="https://docs.cacti.net/manual:087:1_installation.1_install_unix.4_configure_snmp">Net-SNMP guide in the manual</a></p>
<h3 id="testing-the-snmp-connectivity">Testing the SNMP connectivity</h3>
<p>From the Gateway host, run this command :</p>
<pre class="console"><code>$ snmpwalk -v 1 -c mycommunity tcp:192.168.1.2 sysname
SNMPv2-MIB::sysName.0 = STRING: target_server
</code></pre>
<p>From the Cacti server, run this command :</p>
<pre class="console"><code>$ snmpwalk -v 1 -c mycommunity tcp:192.168.0.2:10000 sysname
SNMPv2-MIB::sysName.0 = STRING: target_server
</code></pre>
<p>If everything works fine, your host is then ready to be added to Cacti.</p>
<p>If not, review your network configuration (firewall rules, especially).</p>
<h2 id="adding-the-device-to-cacti">Adding the device to Cacti</h2>
<p>In Cacti, create a new device like that :</p>
<p><img src="images/device-templates-ssh-add-device.png" alt="Add device" /></p>
<p>Voila ! Your target server is graphed by Cacti :)</p>
<hr />
<p><copy>Copyright (c) 2004-2021 The Cacti Group</copy></p>
</body>
</html>
